
!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
custom: aPresentation 
	 
	self subclassResponsibility! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
defaultRenderer 
	 
	^GLMRenderer subclasses first new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
list 
	 
	^self custom: GLMListPresentation new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
mondrian 
	 
	^self custom: GLMMondrianPresentation new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
open 
	 
	^self openWith: self defaultRenderer! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
openOn: anObject 
	 
	^self 
		openOn: anObject 
		with: self defaultRenderer! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
openOn: anObject with: aRenderer 
	 
	self startOn: anObject. 
	^aRenderer open: self! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
openWith: aRenderer 
	 
	^self openOn: nil with: aRenderer! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
startOn: anObject 
	 
	self initializeScriptingDefaults. 
	self entity: anObject! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
text 
	 
	^self custom: GLMTextPresentation new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
tree 
	 
	^self custom: GLMTreePresentation new! !

!GLMListPresentation methodsFor: '*Glamour-Scripting' stamp: 'jorge.ressia 5/22/2009 11:55'!
beMultiple 
	 
	multipleSelection := true! !

!GLMListPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 5/20/2009 14:05'!
beSearchable
	isSearchable := true! !

!GLMListPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
beSingle 
	 
	multipleSelection _ false! !

!GLMListPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
itemAct: aBlock on: aCharacter 
	 
	! !

!GLMListPresentation methodsFor: '*Glamour-Scripting' stamp: 'jorge.ressia 5/22/2009 15:46'!
seachOn: aBlock
	searchBlock := aBlock! !

!GLMListPresentation methodsFor: '*Glamour-Scripting' stamp: 'jorge.ressia 5/22/2009 15:26'!
search: aText on: aList
	 
	self painting 
		glamourValue: 
			((self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: aText with: aList) , self entity] 
				ifFalse: 
					[GLMMultiValue 
						with: aText
						with: aList
						with: self entity])! !

!GLMListPresentation methodsFor: '*Glamour-Scripting' stamp: 'jorge.ressia 5/22/2009 16:08'!
searchStrategy
	^ searchBlock! !

!GLMCustomColumn methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol 
	 
	^self addRow: aBlockOrSymbol! !

!GLMCustomColumn methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol span: anInteger 
	 
	^self addRow: aBlockOrSymbol span: anInteger! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
act: aBlock entitled: aString 
	 
	self 
		addAction: 
			((GLMAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
act: aBlock on: aCharacter 
	 
	self 
		addAction: 
			((GLMAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
act: aBlock on: aCharacter entitled: aString 
	 
	self 
		addAction: 
			((GLMAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
display: aBlock 
	 
	self transformation: aBlock! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 25/2/09 23:39'!
on: aCharacter do: aBlock
	
	self
		addAction:
			((GLMAction new)
				action: aBlock;
				shortcut: aCharacter;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
update: aPortSymbol on: aCharacter with: aBlock 
	 
	self 
		addAction: 
			((GLMAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
when: aBlock 
	 
	self condition: aBlock! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
whenKindOf: aClass 
	 
	self when: [:each | each isKindOf: aClass]! !

!GLMTableLayoutBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol 
	 
	^self addColumn: aBlockOrSymbol! !

!GLMTableLayoutBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol span: anInteger 
	 
	^self addColumn: aBlockOrSymbol span: anInteger! !

!GLMTableLayoutBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol 
	 
	^self addRow: aBlockOrSymbol! !

!GLMTableLayoutBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol span: anInteger 
	 
	^self addRow: aBlockOrSymbol span: anInteger! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
custom: aPresentation 
	 
	scriptTransmission isNil 
		ifTrue: [self addPresentation: aPresentation] 
		ifFalse: [self scriptTransmission addPresentation: aPresentation]. 
	^aPresentation! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
fromPrevious: aPortSymbol 
	 
	self scriptTransmission addActiveOrigin: (GLMPort new name: aPortSymbol)! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
passivelyFromPrevious: aPortSymbol 
	 
	self scriptTransmission addPassiveOrigin: (GLMPort new name: aPortSymbol)! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
scriptTransmission 
	 
	^scriptTransmission 
		ifNil: [scriptTransmission _ GLMBundleTransmission new]! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
using: aBlock 
	 
	aBlock value. 
	self addTransmission: scriptTransmission. 
	scriptTransmission _ nil! !

!GLMCustomRow methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol 
	 
	^self addColumn: aBlockOrSymbol! !

!GLMCustomRow methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol span: anInteger 
	 
	^self addColumn: aBlockOrSymbol span: anInteger! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 11/3/09 10:15'!
capture: aSymbol as: aPort 
	 
	self capturedPorts 
		add: 
			((GLMPublishedPort new) 
				innerPort: aPort; 
				outerPortName: aSymbol; 
				yourself)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
custom: aPresentation 
	"this message sets a custom presentation to the current Transmission. 
	it is to be used within the using: block. 
	this message is particularly useful when you want to set a browser as a presentation" 
	 
	scriptTransmission addPresentation: aPresentation. 
	^aPresentation! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
from: anOriginPortReference 
	"send this message after showOn: to specify an origin for the Transmission. 
	you can cascade several from: to specify additional origins" 
	 
	scriptTransmission 
		addActiveOrigin: (self resolveOriginPort: anOriginPortReference)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
passivelyFrom: anOriginPortReference 
	"passivelyForm: is similar to from: only the origin will be a passive one. 
	in other words, a change in the origin port will not initiate a Transmission" 
	 
	scriptTransmission 
		addPassiveOrigin: (self resolveOriginPort: anOriginPortReference)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 11/3/09 10:15'!
publish: aPort as: aSymbol 
	 
	self publishedPorts 
		add: 
			((GLMPublishedPort new) 
				innerPort: aPort; 
				outerPortName: aSymbol; 
				yourself)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
sendTo: aDesinationPortReference from: anOriginPortReference 
	"this message links two port references with a transmission that holds no presentation" 
	 
	self transmissions 
		addLast: 
			((GLMSimpleTransmission new) 
				origin: (self resolveOriginPort: anOriginPortReference); 
				destination: (self resolveDestinationPort: aDesinationPortReference); 
				yourself)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
sendTo: aDesinationPortReference from: anOriginPortReference with: aBlock 
	"this message links two port references with a transmission that holds no presentation" 
	 
	self transmissions 
		addLast: 
			((GLMSimpleTransformingTransmission new) 
				origin: (self resolveOriginPort: anOriginPortReference); 
				destination: (self resolveDestinationPort: aDesinationPortReference); 
				transmission: aBlock; 
				yourself)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
sendTo: aDesinationPortReference fromOutside: anOriginPortName 
	"this is a shortcut method for propagating inside an outer port name to an inner port reference" 
	 
	self 
		sendTo: aDesinationPortReference 
		from: #outer -> anOriginPortName! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
sendToOutside: aPortName from: anOriginPortReference 
	"this is a shortcut method for exposing an inner port reference as an outer port name" 
	 
	self 
		sendTo: #outer -> aPortName 
		from: anOriginPortReference! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
showOn: aDestinationPane 
	"send this message when at the beginning of specifying a Transmission" 
	 
	scriptTransmission _ (GLMBundleTransmission new) 
		destination: (self resolveDestinationPort: aDestinationPane); 
		yourself! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
using: aBlock 
	"this message should be sent after showOn: and a sequence of from: messages. 
	the using: message takes a block as a parameter to specify the presentations that accompany the Transmission" 
	 
	aBlock value. 
	scriptTransmission origins isEmpty 
		ifTrue: [self addJumpstart: scriptTransmission] 
		ifFalse: [self addTransmission: scriptTransmission]. 
	scriptTransmission _ nil! !
